SystemOrganization addCategory: #'MorphicTests-Basic'!
SystemOrganization addCategory: #'MorphicTests-Kernel'!
SystemOrganization addCategory: #'MorphicTests-Text Support'!
SystemOrganization addCategory: #'MorphicTests-Widgets'!
SystemOrganization addCategory: #'MorphicTests-WindowNotification'!

HashAndEqualsTestCase subclass: #TextAnchorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicTests-Text Support'!

!TextAnchorTest methodsFor: 'initialization' stamp: 'mjr 8/20/2003 18:55'!
setUp
	super setUp.
	prototypes
		add: (TextAnchor new anchoredMorph: RectangleMorph new initialize);
		
		add: (TextAnchor new anchoredMorph: EllipseMorph new initialize) ! !

HashAndEqualsTestCase subclass: #TextLineTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicTests-Text Support'!

!TextLineTest methodsFor: 'initialization' stamp: 'mjr 8/20/2003 18:56'!
setUp
	super setUp.
	prototypes
		add: (TextLine
				start: 1
				stop: 50
				internalSpaces: 2
				paddingWidth: 1) ! !

Morph subclass: #TestInWorldMorph
	instanceVariableNames: 'intoWorldCount outOfWorldCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicTests-Kernel'!

!TestInWorldMorph commentStamp: 'sd 6/5/2005 10:25' prior: 0!
Helper class for MorphTest!

!TestInWorldMorph methodsFor: 'as yet unclassified' stamp: 'ar 8/4/2003 00:06'!
initialize
	super initialize.
	outOfWorldCount := intoWorldCount := 0.! !

!TestInWorldMorph methodsFor: 'as yet unclassified' stamp: 'ar 8/4/2003 00:03'!
intoWorld: aWorld
	aWorld ifNil:[^self].
	super intoWorld: aWorld.
	intoWorldCount := intoWorldCount + 1.
! !

!TestInWorldMorph methodsFor: 'as yet unclassified' stamp: 'ar 8/4/2003 00:06'!
intoWorldCount
	^intoWorldCount! !

!TestInWorldMorph methodsFor: 'as yet unclassified' stamp: 'ar 8/4/2003 00:03'!
outOfWorld: aWorld
	aWorld ifNil:[^self].
	super outOfWorld: aWorld.
	outOfWorldCount := outOfWorldCount + 1.
! !

!TestInWorldMorph methodsFor: 'as yet unclassified' stamp: 'ar 8/4/2003 00:06'!
outOfWorldCount
	^outOfWorldCount! !

ClassTestCase subclass: #TextMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicTests-Basic'!

!TextMorphTest methodsFor: 'testing' stamp: 'md 11/13/2003 10:01'!
testInitialize
	"For now, just make sure initialization doesn't throw exception"

	self shouldnt: [TextMorph initialize] raise: Error.! !

TestCase subclass: #BalloonFontTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicTests-Widgets'!

!BalloonFontTest methodsFor: 'tests' stamp: 'sd 12/9/2001 21:44'!
testDefaultFont
	"(self selector: #testDefaultFont) debug"
	self assert: RectangleMorph new balloonFont = BalloonMorph balloonFont.
	self assert: RectangleMorph new defaultBalloonFont = BalloonMorph balloonFont.! !

!BalloonFontTest methodsFor: 'tests' stamp: 'sd 12/9/2001 21:55'!
testSpecificFont
	"(self selector: #testSpecificFont) debug"
	| aMorph |
	aMorph := RectangleMorph new.
	self assert: RectangleMorph new balloonFont = BalloonMorph balloonFont.
	self assert: RectangleMorph new defaultBalloonFont = BalloonMorph balloonFont.
	aMorph
		balloonFont: (StrikeFont familyName: #ComicPlain size: 19).
	self assert: aMorph balloonFont
			= (StrikeFont familyName: #ComicPlain size: 19).
	"The next test is horrible because I do no know how to access the font 
	with the appropiate interface"
	self assert: (((BalloonMorph getTextMorph: 'lulu' for: aMorph) text runs at: 1)
			at: 1) font
			= (StrikeFont familyName: #ComicPlain size: 19)! !

TestCase subclass: #LayoutFrameTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicTests-Basic'!

!LayoutFrameTest methodsFor: 'tests' stamp: 'StephaneDucasse 4/28/2010 22:19'!
testInset
	| lf rectangle |
	lf := LayoutFrame new
			leftFraction: 0 offset: 10;
			topFraction: 0 offset: 10;
			rightFraction: 1 offset: -10;
			bottomFraction: 1 offset: -10;
			yourself.
	rectangle := lf layout: nil in: (50@10 corner: 150@70).
	self assert: (60@20 corner: 140@60) = rectangle! !

!LayoutFrameTest methodsFor: 'tests' stamp: 'StephaneDucasse 4/28/2010 22:20'!
testLeftTopAligned
	| lf rectangle |
	lf := LayoutFrame new
		leftFraction: 0 offset: 10;
		topFraction: 0 offset: 10;
		rightFraction: 0 offset: 60;
		bottomFraction: 0 offset: 25;
		yourself.
	rectangle := lf layout: nil in: (50@10 corner: 150@70).
	self assert: (60@20 corner: 110@35) = rectangle! !

!LayoutFrameTest methodsFor: 'tests' stamp: 'StephaneDucasse 4/28/2010 22:18'!
testRightBottomQuadrant
	| lf rectangle |
	lf := LayoutFrame new
			leftFraction: 1/2 offset: 1;
			topFraction: 1/2 offset: 1;
			rightFraction: 1 offset: -2;
			bottomFraction: 1 offset: -2;
			yourself.
	rectangle := lf layout: nil in: (50@10 corner: 150@70).
	self assert: (101@41 corner: 148@68) = rectangle! !

!LayoutFrameTest methodsFor: 'tests' stamp: 'StephaneDucasse 4/28/2010 22:20'!
testSpaceFill
	| lf rectangle |
	lf := LayoutFrame new
			leftFraction: 0 offset: 0;
			topFraction: 0 offset: 0;
			rightFraction: 1 offset: 0;
			bottomFraction: 1 offset: 0;
			yourself.
	rectangle := lf layout: nil in: (50@10 corner: 150@70).
	self assert: (50@10 corner: 150@70) = rectangle! !

TestCase subclass: #LogoImageMorphTest
	instanceVariableNames: 'defaultLogo logo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicTests-Widgets'!

!LogoImageMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 3/19/2010 14:37'!
assertDefaultLogoLookAndFeelPropertiesFor: aLogo
	self assert: aLogo isInWorld.
	self assert: aLogo visible.
	self assert: aLogo isSticky.
	self assert: World submorphs last == aLogo! !

!LogoImageMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 3/17/2010 17:33'!
setUp
	super setUp.
	defaultLogo := LogoImageMorph default.
	logo := LogoImageMorph new.
! !

!LogoImageMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 3/19/2010 14:39'!
tearDown
	super tearDown.
	defaultLogo openInWorld; show.
	LogoImageMorph default: defaultLogo.
	logo delete! !

!LogoImageMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 3/19/2010 14:00'!
testReplacingNilDefaultLogoWithAnotherLogo
	self testReplacingNotNilDefaultLogoWithNil.
	self shouldnt: [LogoImageMorph default: defaultLogo] raise: Error.
	self assertDefaultLogoLookAndFeelPropertiesFor: defaultLogo! !

!LogoImageMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 3/19/2010 14:01'!
testReplacingNotNilDefaultLogoWithAnotherLogo
	self assertDefaultLogoLookAndFeelPropertiesFor: defaultLogo.
	self deny: logo isInWorld.
	LogoImageMorph default: logo.
	self assertDefaultLogoLookAndFeelPropertiesFor: logo.
	self deny: defaultLogo isInWorld.
! !

!LogoImageMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 3/17/2010 17:35'!
testReplacingNotNilDefaultLogoWithNil
	self shouldnt: [LogoImageMorph default: nil] raise: Error.
	self deny: defaultLogo isInWorld.
! !

TestCase subclass: #MCPTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicTests-Kernel'!

!MCPTest methodsFor: 'constants' stamp: 'dgd 2/14/2003 10:13'!
defaultBounds
	"the default bounds for morphs"
	^ 0 @ 0 corner: 50 @ 40 ! !

!MCPTest methodsFor: 'constants' stamp: 'dgd 2/14/2003 10:13'!
defaultTop
	"the default top for morphs"
	^ self defaultBounds top ! !

!MCPTest methodsFor: 'tests' stamp: 'gm 2/22/2003 12:58'!
testIsMorphicModel
	"test isMorphicModel"
	self deny: Object new isMorphicModel.
	self deny: Morph new isMorphicModel.
	self assert: MorphicModel new isMorphicModel.
! !

!MCPTest methodsFor: 'tests' stamp: 'dgd 2/14/2003 10:15'!
testTop
	"test the #top: messages and its consequences"

	| morph factor newTop newBounds |
	morph := Morph new.
	""
	factor := 10.
	newTop := self defaultTop + factor.
	newBounds := self defaultBounds translateBy: 0 @ factor.
	""
	morph top: newTop.
	""
	self assert: morph top = newTop;
		 assert: morph bounds = newBounds! !

TestCase subclass: #MorphTest
	instanceVariableNames: 'morph world'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicTests-Kernel'!

!MorphTest commentStamp: '<historical>' prior: 0!
This is the unit test for the class Morph. Unit tests are a good way to exercise the functionality of your system in a repeatable and automatic manner. They are therefore recommended if you plan to release anything. For more information, see: 
	- http://www.c2.com/cgi/wiki?UnitTest
	- http://minnow.cc.gatech.edu/squeak/1547
	- the sunit class category!

MorphTest subclass: #CircleMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicTests-Basic'!

!CircleMorphTest commentStamp: 'tlk 5/21/2006 14:16' prior: 0!
A CircleMorphTest is a subclass of MorphTest.  It was first implemented when removing some unused and broken functionality.

My fixtures are morph, a CircleMorph and world.
!

!CircleMorphTest methodsFor: 'initialization' stamp: 'tlk 5/21/2006 14:17'!
setUp
	morph := CircleMorph new! !

!MorphTest methodsFor: 'initialization' stamp: 'tak 1/21/2005 11:12'!
setUp
	morph := Morph new! !

!MorphTest methodsFor: 'initialization' stamp: 'StephaneDucasse 11/6/2009 17:55'!
tearDown
	morph delete.
	! !

!MorphTest methodsFor: 'testing - geometry' stamp: 'Alexandre Bergel 8/2/2010 12:27'!
testExtent
	"
	self debug: #testExtent
	"
	| m1 m2 v1 v2 v3 b1 b2 |
	m1 := Morph new.
	m2 := Morph new.
	
	v1 := 100.000001.
	v2 := 100.000001000001.
	v3 := 100.000001000002.

	m1 extent: v1@v1.
	b1 := m1 bounds.
	
	m2 extent: v2@v3.
	b2 := m2 bounds.
	
	self assert: (b2 = b1).
! !

!MorphTest methodsFor: 'testing - into/outof world' stamp: 'ar 8/4/2003 00:11'!
testIntoWorldCollapseOutOfWorld
	| m1 m2 collapsed |
	"Create the guys"
	m1 := TestInWorldMorph new.
	m2 := TestInWorldMorph new.
	self assert: (m1 intoWorldCount = 0).
	self assert: (m1 outOfWorldCount = 0).
	self assert: (m2 intoWorldCount = 0).
	self assert: (m2 outOfWorldCount = 0).

	"add them to basic morph"
	morph addMorphFront: m1.
	m1 addMorphFront: m2.
	self assert: (m1 intoWorldCount = 0).
	self assert: (m1 outOfWorldCount = 0).
	self assert: (m2 intoWorldCount = 0).
	self assert: (m2 outOfWorldCount = 0).

	"open the guy"
	morph openInWorld.
	self assert: (m1 intoWorldCount = 1).
	self assert: (m1 outOfWorldCount = 0).
	self assert: (m2 intoWorldCount = 1).
	self assert: (m2 outOfWorldCount = 0).

	"collapse it"
	collapsed := 	CollapsedMorph new beReplacementFor: morph.
	self assert: (m1 intoWorldCount = 1).
	self assert: (m1 outOfWorldCount = 1).
	self assert: (m2 intoWorldCount = 1).
	self assert: (m2 outOfWorldCount = 1).

	"expand it"
	collapsed collapseOrExpand.
	self assert: (m1 intoWorldCount = 2).
	self assert: (m1 outOfWorldCount = 1).
	self assert: (m2 intoWorldCount = 2).
	self assert: (m2 outOfWorldCount = 1).

	"delete it"
	morph delete.
	self assert: (m1 intoWorldCount = 2).
	self assert: (m1 outOfWorldCount = 2).
	self assert: (m2 intoWorldCount = 2).
	self assert: (m2 outOfWorldCount = 2).
! !

!MorphTest methodsFor: 'testing - into/outof world' stamp: 'ar 8/4/2003 00:12'!
testIntoWorldDeleteOutOfWorld
	| m1 m2 |
	"Create the guys"
	m1 := TestInWorldMorph new.
	m2 := TestInWorldMorph new.
	self assert: (m1 intoWorldCount = 0).
	self assert: (m1 outOfWorldCount = 0).
	self assert: (m2 intoWorldCount = 0).
	self assert: (m2 outOfWorldCount = 0).

	morph addMorphFront: m1.
	m1 addMorphFront:  m2.
	self assert: (m1 intoWorldCount = 0).
	self assert: (m1 outOfWorldCount = 0).
	self assert: (m2 intoWorldCount = 0).
	self assert: (m2 outOfWorldCount = 0).

	morph openInWorld.
	self assert: (m1 intoWorldCount = 1).
	self assert: (m1 outOfWorldCount = 0).
	self assert: (m2 intoWorldCount = 1).
	self assert: (m2 outOfWorldCount = 0).

	morph delete.
	self assert: (m1 intoWorldCount = 1).
	self assert: (m1 outOfWorldCount = 1).
	self assert: (m2 intoWorldCount = 1).
	self assert: (m2 outOfWorldCount = 1).
	! !

!MorphTest methodsFor: 'testing - into/outof world' stamp: 'ar 8/10/2003 18:30'!
testIntoWorldTransferToNewGuy
	| m1 m2 |
	"Create the guys"
	m1 := TestInWorldMorph new.
	m2 := TestInWorldMorph new.
	self assert: (m1 intoWorldCount = 0).
	self assert: (m1 outOfWorldCount = 0).
	self assert: (m2 intoWorldCount = 0).
	self assert: (m2 outOfWorldCount = 0).

	morph addMorphFront: m1.
	m1 addMorphFront:  m2.
	self assert: (m1 intoWorldCount = 0).
	self assert: (m1 outOfWorldCount = 0).
	self assert: (m2 intoWorldCount = 0).
	self assert: (m2 outOfWorldCount = 0).

	morph openInWorld.
	self assert: (m1 intoWorldCount = 1).
	self assert: (m1 outOfWorldCount = 0).
	self assert: (m2 intoWorldCount = 1).
	self assert: (m2 outOfWorldCount = 0).

	morph addMorphFront: m2.
	self assert: (m1 intoWorldCount = 1).
	self assert: (m1 outOfWorldCount = 0).
	self assert: (m2 intoWorldCount = 1).
	self assert: (m2 outOfWorldCount = 0).

	morph addMorphFront: m1.
	self assert: (m1 intoWorldCount = 1).
	self assert: (m1 outOfWorldCount = 0).
	self assert: (m2 intoWorldCount = 1).
	self assert: (m2 outOfWorldCount = 0).

	m2 addMorphFront: m1.
	self assert: (m1 intoWorldCount = 1).
	self assert: (m1 outOfWorldCount = 0).
	self assert: (m2 intoWorldCount = 1).
	self assert: (m2 outOfWorldCount = 0).

	morph delete.
	self assert: (m1 intoWorldCount = 1).
	self assert: (m1 outOfWorldCount = 1).
	self assert: (m2 intoWorldCount = 1).
	self assert: (m2 outOfWorldCount = 1).
! !

!MorphTest methodsFor: 'testing - classification' stamp: 'md 4/16/2003 17:11'!
testIsMorph
	self assert: (morph isMorph).! !

!MorphTest methodsFor: 'testing - initialization' stamp: 'md 4/16/2003 17:10'!
testOpenInWorld
	self shouldnt: [morph openInWorld] raise: Error.! !

MorphTest subclass: #PolygonMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicTests-Basic'!

!PolygonMorphTest commentStamp: 'nice 2/16/2008 02:13' prior: 0!
This class holds tests for PolygonMorph!

!PolygonMorphTest methodsFor: 'bounds' stamp: 'nice 2/16/2008 02:31'!
testBoundsBug1035
	"This is a non regression test for http://bugs.squeak.org/view.php?id=1035
	PolygonMorph used to position badly when container bounds were growing"
	
	| submorph aMorph |
	
	submorph := (PolygonMorph
		vertices: {0@0. 100@0. 0@100}
		color: Color red borderWidth: 0 borderColor: Color transparent)
			color: Color red.

	submorph bounds. "0@0 corner: 100@100"

	aMorph := Morph new
		color: Color blue;
		layoutPolicy: ProportionalLayout new;
		addMorph: submorph
		fullFrame: (LayoutFrame fractions: (0.1 @ 0.1 corner: 0.9 @ 0.9)).

	submorph bounds. "0@0 corner: 100@100 NOT YET UPDATED"
	aMorph fullBounds. "0@0 corner: 50@40. CORRECT"
	submorph bounds. "5@4 corner: 45@36 NOW UPDATED OK"

	aMorph extent: 100@100.
	submorph bounds. "5@4 corner: 45@36 NOT YET UPDATED"
	aMorph fullBounds. "-10@-14 corner: 100@100 WRONG"
	submorph bounds. "-10@-14 corner: 70@66 NOW WRONG POSITION (BUT RIGHT EXTENT)"

	self assert: aMorph fullBounds = (0 @ 0 extent: 100@100).
	self assert: submorph bounds = (10 @ 10 corner: 90@90).
! !

TestCase subclass: #NewTextMorphTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicTests-Text Support'!

!NewTextMorphTests methodsFor: 'new text morph' stamp: 'FernandoOlivero 6/6/2010 16:09'!
keyboardEvent 
	| event |
	event := KeyboardEvent new.
	event 
		setType: #keystroke
		buttons: 0
		position:  0@0
		keyValue: 0
		charCode: 0
		hand: nil 
		stamp: Time now.
	^ event 	! !

!NewTextMorphTests methodsFor: 'new text morph' stamp: 'StephaneDucasse 7/7/2010 18:47'!
testAcceptContents
	| textMorph cmdSkeyboardEvent |
	textMorph := NewTextMorph new.
	textMorph onAcceptSend: #delete to: textMorph.
	textMorph openInWorld.
	[
		cmdSkeyboardEvent := KeyboardEvent new.
		cmdSkeyboardEvent
		setType: #keystroke
		buttons: 64 
		position:  textMorph position 
		keyValue: 115
		hand:  textMorph activeHand 
		stamp: DateAndTime now.
		self assert: textMorph owner notNil description: 'precondition'.
		textMorph editor  dispatchOn: cmdSkeyboardEvent.
		self assert: textMorph owner isNil ] 
	ensure:[ textMorph delete  ] ! !

!NewTextMorphTests methodsFor: 'new text morph' stamp: 'FernandoOlivero 6/20/2010 21:46'!
testAutoFitToParagraph
	| morph margin borderWidth|
	morph := NewTextMorph new.
	morph bounds: (0@0 extent: 0@0).
	morph autoFit: false.
	morph text:'hola' asText . 	
	self assert: morph extent = (0@0).
	morph autoFit: true.
	morph text:'hola' asText . 	
	self assert: morph extent > ( 0@0).
	! !

!NewTextMorphTests methodsFor: 'new text morph' stamp: 'FernandoOlivero 6/15/2010 16:01'!
testCreation 
	| morph contents |
	morph := NewTextMorph new.
	contents := 'Hello, i am a new text morph, using the new editors'.
	morph text:  contents . 	
	self
		assert:  morph paragraph string =  contents ;
		assert: morph text = contents asText ;
		deny: morph acceptOnCR ;
		assert: morph  editor isTextEditor ;
		assert: morph bounds = morph initialBounds ;
		assert: morph padding = morph defaultPadding ;
		assert: morph borderStyle = morph defaultBorderStyle.! !

!NewTextMorphTests methodsFor: 'displaying errors' stamp: 'FernandoOlivero 9/2/2010 14:45'!
testDefaultEditorHasError
	| e |
	e := EntryFieldMorph new.
	e contents: 'hello'.
	self deny: e hasErrors .! !

!NewTextMorphTests methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 9/2/2010 14:46'!
testEntryFieldIsDirty
	| e |
	e := EntryFieldMorph new.
	self assert: e isDirty not.
	e contents: 'hello'.
	self assert: e isDirty.! !

!NewTextMorphTests methodsFor: 'new text morph' stamp: 'FernandoOlivero 6/17/2010 00:40'!
testFittingToParagraph
	| morph unitForAdjustXBug |
	morph := NewTextMorph new.
	morph
		borderWidth: 0;
		padding: 0 ;
		text: 'I am a clipped text morph, make me show everything by sending me fitToParagraph' asText . 	
	self deny: morph extent = morph paragraph extent description: 'precondition'.
	morph fitToParagraph.
	self assert: morph extent  =  morph paragraph extent  .
	morph
		borderWidth: 1;
		padding: 2; 
		fitToParagraph.
	self assert: morph extent =  ( morph paragraph extent  + 6 ).! !

!NewTextMorphTests methodsFor: 'new text morph' stamp: 'FernandoOlivero 6/16/2010 11:39'!
testParagraphCompositionRectangle
	| morph |
	morph := NewTextMorph new.
	morph text: 'I am a clipped text morph, make me show everything by sending me fitToParagraph' . 	
	morph borderWidth: 0.
	morph padding: 0.
	self assert: morph paragraph compositionRectangle extent  = morph extent.
	morph borderWidth: 1.
	self assert: morph paragraph compositionRectangle extent  = ( morph extent - 2 ).
	morph padding: 2.
	self assert: morph paragraph compositionRectangle extent  = ( morph extent - 2 - 4 ).! !

!NewTextMorphTests methodsFor: 'new text morph' stamp: 'FernandoOlivero 6/16/2010 11:44'!
testParagraphExtent
	| morph |
	morph := NewTextMorph new.
	morph text: 'I am a clipped text morph, make me show everything by sending me fitToParagraph' . 	
	morph borderWidth: 0.
	morph padding: 0.
	self assert: morph paragraph extent x = morph extent x.
	self assert: morph paragraph extent y <= morph extent y.
	morph borderWidth: 1.
	self assert: morph paragraph extent x = ( morph extent - 2 ) x .
	self assert: morph paragraph extent y <= morph extent y.
	morph padding: 2.
	self assert: morph paragraph extent x  = ( morph extent - 2 - 4 ) x.
	self assert: morph paragraph extent y <= morph extent y.
! !

!NewTextMorphTests methodsFor: 'new text morph' stamp: 'FernandoOlivero 6/15/2010 16:17'!
testParagraphPosition
	| morph |
	morph := NewTextMorph new.
	morph borderWidth: 0.
	morph padding: 0.
	morph bounds: (0@0 extent: 100@100).
	morph text: 'Hello i am a new text morph' . 	
	self assert: 0@0 =  morph paragraph compositionRectangle origin.
	morph borderWidth: 1.
	self assert:  1@ 1 =  ( morph paragraph compositionRectangle origin ). 
	morph padding: 2.
	self assert:  3@ 3 =  ( morph paragraph compositionRectangle origin ) 
	
	
	! !

!NewTextMorphTests methodsFor: 'new text morph' stamp: 'FernandoOlivero 6/15/2010 15:56'!
testParagraphPositionWhenMoved
	| morph |
	morph := NewTextMorph new.
	morph borderWidth: 0.
	morph padding: 0.
	morph bounds: (0@0 extent: 100@100).
	morph text: 'Hello i am a new text morph' . 		
	self assert: 0@0 =  morph paragraph compositionRectangle origin.
	morph position: 10@10.
	self assert:  10@10 =  morph paragraph compositionRectangle origin.
	
	
	! !

TestCase subclass: #TranscriptMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicTests-Widgets'!

!TranscriptMorphTest methodsFor: 'read only' stamp: 'FernandoOlivero 6/11/2011 13:49'!
testReadOnlyMorphBounds
	| m model initialBounds  |
	model := TranscriptModel new. 
	initialBounds := model bounds.
	m := TranscriptReadOnlyMorph on: model.
	self
		assert: model bounds = m bounds 
		description: 'the transcript model should have been placed below the morph'.	
	m bounds: ( initialBounds translateBy: (189@15) ).
	self
		assert: model bounds = m bounds 
		description: 'the transcript model should have been placed below the morph'.! !

!TranscriptMorphTest methodsFor: 'read only' stamp: 'FernandoOlivero 6/11/2011 13:49'!
testReadOnlyMorphDisplaying
	| m model |
	model := TranscriptModel new. 
	self deny: model showsOnDisplay description: 'precondition'.
	m := TranscriptReadOnlyMorph on: model.
	self deny: model showsOnDisplay description: 'only when the morph is added to the world'.
	[ 
		m openInWorld.
		self assert: model showsOnDisplay .
		m delete.
		self deny: model showsOnDisplay .		
	] ensure:[ m delete ].
	! !

!TranscriptMorphTest methodsFor: 'writable' stamp: 'FernandoOlivero 6/11/2011 13:51'!
testWritableMorphBounds
	| model m |
	model := TranscriptModel new.
	m := TranscriptContentsMorph on: model.! !

!TranscriptMorphTest methodsFor: 'writable' stamp: 'FernandoOlivero 6/11/2011 13:54'!
testWritableMorphDependents
	| model m |
	model := TranscriptModel new.
	m := TranscriptContentsMorph on: model.
	self assert: ( model dependents includes: m ).
	m model: nil.
	self deny: ( model dependents includes: m ).
	m model: model.
	self assert: ( model dependents includes: m ).
	m delete.
	self deny: ( model dependents includes: m ).! !

!TranscriptMorphTest methodsFor: 'writable' stamp: 'FernandoOlivero 6/11/2011 13:52'!
testWritableMorphDisplay
	| model m |
	model := TranscriptModel new.
	m := TranscriptContentsMorph on: model.
	self deny: model showsOnDisplay description:'only read only morphs uses the super fast transcript model drawOn: feature'.! !

TestCase subclass: #WindowAnnouncementTest
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicTests-WindowNotification'!

!WindowAnnouncementTest methodsFor: 'running' stamp: 'Alexandre Bergel 1/12/2010 11:16'!
tearDown 
	super tearDown.
	window ifNotNil: [ window delete ]! !

!WindowAnnouncementTest methodsFor: 'window change' stamp: 'Alexandre Bergel 1/12/2010 11:16'!
testCollapsing
	| t |
	window := SystemWindow labelled: 'foo'.
	t := 0.
	window openInWorld.
	window announcer on: WindowCollapsed do: [:ann | t := t + 1].
	self assert: (t = 0).
	window collapse.
	self assert: (t = 1).
! !

!WindowAnnouncementTest methodsFor: 'window change' stamp: 'Alexandre Bergel 1/13/2010 10:36'!
testMoving
	| t oldBounds newBounds event |
	window := SystemWindow labelled: 'foo'.
	t := 0.
	event := nil.

	window openInWorld.
	oldBounds := window bounds.
	window announcer on: WindowMoved do: [:ann | t := t + 1. event := ann].

	self assert: (t = 0).
	self assert: (event isNil).
	
	"We move the window"
	window position: 50@50.
	self assert: (t = 1).
	self assert: (event oldPosition = oldBounds origin).
	self assert: (event newPosition = (50@50 )).

	"We call position: without moving it actually, nothing should happen"
	window position: 50@50.
	self assert: (t = 1).

	"If we simply resize the window, nothing should happen as well"
	window extent: 50@60.
	self assert: (t = 1).

! !

!WindowAnnouncementTest methodsFor: 'window change' stamp: 'Alexandre Bergel 1/13/2010 10:20'!
testResizing
	| t oldBounds newBounds |
	window := SystemWindow labelled: 'foo'.
	t := 0.
	window openInWorld.
	oldBounds := window bounds.
	window announcer on: WindowResizing do: [:ann | t := t + 1].
	self assert: (t = 0).
	window extent: 50@60.
	newBounds := window bounds.
	self assert: (t = 1).
! !

!WindowAnnouncementTest methodsFor: 'window creation and deletion' stamp: 'Alexandre Bergel 1/13/2010 10:34'!
testResizingClosing
	| coll |

	window := SystemWindow labelled: 'foo'.
	coll := OrderedCollection new.
	window openInWorld.
	window announcer on: WindowAnnouncement do: [:ann | coll add: ann].
	self assert: (coll isEmpty).
	window minimizeOrRestore.
	
	"Resizing, moving, collapsing "
	self assert: (coll size = 3).
	self assert: (coll first isResized).
	self assert: (coll second isMoved).
	self assert: (coll third isCollapsed).
	window delete.

	self assert: (coll size = 4).
	self assert: (coll fourth isClosed).
	window := nil! !

!WindowAnnouncementTest methodsFor: 'window change' stamp: 'Alexandre Bergel 1/13/2010 10:19'!
testScrolling

	| myMorph pane t |
	window := SystemWindow labelled: 'foo'.
	myMorph := Morph new.
	myMorph extent: 1000@1000.
	pane := ScrollPane new.
	pane scroller addMorph: myMorph.
	window
		addMorph: pane
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1)).

	t := 0 @ 0.
	window openInWorld.
	window announcer on: WindowScrolling do: [:ann | t := t + ann step ].
	pane hScrollBarValue: 10.
	pane vScrollBarValue: 5.

	window delete.
	
	self assert: (t = (10 @ 5)).
	window := nil! !

!WindowAnnouncementTest methodsFor: 'window creation and deletion' stamp: 'Alexandre Bergel 1/13/2010 10:20'!
testWindowCreation
	| t oldBounds newBounds |
	t := 0.
	World announcer on: WindowResizing do: [:ann | t := t + 1].
	window := SystemWindow labelled: 'foo'.
	window openInWorld.
	oldBounds := window bounds.
	window announcer on: WindowResizing do: [:ann | t := t + 1].
	self assert: (t = 0).
	window extent: 50@60.
	newBounds := window bounds.
	self assert: (t = 1).
! !

!WindowAnnouncementTest methodsFor: 'window creation and deletion' stamp: 'Alexandre Bergel 1/12/2010 11:17'!
testWindowCreationAndDeletion
	
	| t newWindowCreated r |
	t := 0.
	World announcer on: WindowOpened do: [:ann | t := t + 1. newWindowCreated := ann window].
	World announcer on: WindowClosed do: [:ann | t := t + 10. newWindowCreated := ann window].
	window := SystemWindow labelled: 'foo'.
	window openInWorld.

	self assert: (t = 1).
	self assert: (window == newWindowCreated).
	window delete.

	self assert: (t = 11).
	self assert: (window == newWindowCreated).
! !

!WindowAnnouncementTest methodsFor: 'window creation and deletion' stamp: 'GaryChambers 6/10/2011 13:14'!
testWindowLabelling
	"Test change of label for a window."
	
	|labels win|
	labels := #().
	World announcer on: WindowLabelled do: [:ann | win := ann window. labels := labels copyWith: ann label].
	window := SystemWindow labelled: 'foo'.
	window openInWorld.
	self assert: win = window.
	self assert: labels = #('foo').
	window setLabel: 'bar'.
	self assert: win = window.
	self assert: labels = #('foo' 'bar')! !
